%define name        xen
%define version     4.3.1
%define release     %mkrel 2
%define major       3.0
%define libname     %mklibname %{name} %{major}
%define develname   %mklibname %{name} -d

Name:       %{name}
Version:    %{version}
Release:    %{release}
Summary:    The basic tools for managing XEN virtual machines
Group:      System/Kernel and hardware
License:    GPL
URL:        http://xen.org/
Source0:    http://bits.xensource.com/oss-xen/release/%{version}/%{name}-%{version}.tar.gz
Source1:    %{name}.modules
Source2:    qemu-xen-4.0.0-rc4.tar.gz
Source3:    http://xenbits.xen.org/xen-extfiles/libconfig-1.3.2.tar.gz
# stubdoms
Source10:   http://xenbits.xen.org/xen-extfiles/zlib-1.2.3.tar.gz
Source11:   http://xenbits.xen.org/xen-extfiles/newlib-1.16.0.tar.gz
Source12:   http://xenbits.xen.org/xen-extfiles/grub-0.97.tar.gz
Source13:   http://xenbits.xen.org/xen-extfiles/lwip-1.3.0.tar.gz
Source14:   http://xenbits.xen.org/xen-extfiles/pciutils-2.2.9.tar.bz2
Source15:   ocaml-3.11.0.tar.gz
Source16:   http://xenbits.xen.org/xen-extfiles/ipxe-git-9a93db3f0947484e30e753bbd61a10b17336e20e.tar.gz
Source17:   http://xenbits.xen.org/xen-extfiles/polarssl-1.1.4-gpl.tgz
# initscripts
Source20:   init.xenstored 
Source21:   init.xenconsoled
Source22:   init.blktapctrl
Source23:   init.xend
Source30:   sysconfig.xenstored
Source31:   sysconfig.xenconsoled
Source32:   sysconfig.blktapctrl
Source33:   %{name}-tmpfiles.conf
# Mageia patches:
Patch0:     xen-4.1.2-fix-stubdom-Makefile.patch
Patch2:     xen-4.1.3-fix-doc-build.patch
Patch3:     xen-4.2.1-fix-glibc-build.patch
Patch4:     xencommons-fix-service.patch
Patch5:     xen-4.2-ocaml-build.patch
# fedora patches
Patch13:    qemu-xen.tradonly.patch
Patch14:    xen-4.2.1-fix-xg-build.patch
Patch15:    xen.pygrubtitlefix.patch
# security patches
Patch1073:  xsa73.patch
Patch1075:  xsa75.patch
Requires:   python
Requires:   python-twisted-core
Requires:   python-pyxml
Requires:   kmod
Requires:   iptables
Requires:   bridge-utils
Requires:   glibc-xen
Requires:   grub
Requires:   kernel-server
Requires:   %{libname} = %{version}-%{release}
Requires:   xen-hypervisor = %{version}
Requires(post):  systemd >= %{systemd_required_version}
Requires(post):  rpm-helper
Requires(preun): rpm-helper
BuildRequires:  SDL-devel
BuildRequires:  libx11-devel
BuildRequires:  gtk2-devel
BuildRequires:  curl-devel
BuildRequires:  dev86-devel
BuildRequires:  libext2fs-devel
BuildRequires:  ncurses-devel
BuildRequires:  libpython-devel >= 2.4
BuildRequires:  zlib-devel
BuildRequires:  bzip2-devel
BuildRequires:  lzma-devel
BuildRequires:  pciutils-devel
BuildRequires:  libidn-devel
BuildRequires:  openssl-devel
BuildRequires:  gnutls-devel
BuildRequires:	libgcrypt-devel
BuildRequires:  brlapi-devel
BuildRequires:  e2fsprogs-devel
BuildRequires:  libuuid-devel
BuildRequires:  ocaml
BuildRequires:  ocaml-findlib-devel
BuildRequires:  yajl-devel
BuildRequires:  iasl
BuildRequires:  vde-devel
BuildRequires:  libaio-devel
BuildRequires:  gettext
BuildRequires:  libconfig-devel
# documentation
BuildRequires:  ghostscript
BuildRequires:  transfig
BuildRequires:  texinfo
BuildRequires:  tetex-latex
BuildRequires:  texi2html
Obsoletes:      xen-uptodate

# security patches

%description 
The basic tools for managing XEN virtual machines.

%package -n ocaml-xen
Summary: Ocaml bindings for Xen
Group: Development/Other
Obsoletes: xen-ocaml < %{version}-%{release}

%description -n ocaml-xen
This package contains the Ocaml bindings for Xen

%package -n ocaml-xen-devel
Summary: Static libraries and header files for Ocaml bindings for Xen
Group: Development/Other
Requires: %{name}-devel = %{version}-%{release}

%description -n ocaml-xen-devel
This package contains the libraries and headers needed only to compile
applications linked on Ocaml bindings for Xen.

%package hypervisor
Summary: Libraries for Xen tools
Group: System/Kernel and hardware

%description hypervisor
This package contains the Xen hypervisor

%package doc
Summary:    XEN documentation
Group:      System/Kernel and hardware
Obsoletes:  xen-uptodate-doc

%description doc
XEN documentation.

%package -n %{libname}
Summary:    Libraries for %{name}
Group:      System/Libraries
Conflicts:  %{name} < 3.1.0-5

%description -n %{libname}
This package contains the libraries needed to run programs dynamically
linked with Xen libraries.

%package -n %{develname}
Summary:    Static libraries and header files for %{name}
Group:      Development/C
Requires:   %{libname} = %{version}-%{release}
Provides:   %{name}-devel = %{version}-%{release}
Conflicts:  %{name} < 3.1.0-5

%description -n %{develname}
This package contains the static development libraries and headers needed
to compile applications linked with Xen libraries.

%prep
%setup -q
%apply_patches

# stub domain
cp %{SOURCE10} stubdom
cp %{SOURCE11} stubdom
cp %{SOURCE12} stubdom
cp %{SOURCE13} stubdom
cp %{SOURCE14} stubdom
cp %{SOURCE15} stubdom
cp %{SOURCE17} stubdom

cp %{SOURCE16} tools/firmware/etherboot/ipxe.tar.gz

# qemu
tar xf %{SOURCE2} -C tools

%build
# clean all stuff
export CFLAGS="%{optflags}"

%ifnarch %{ix86}
%make prefix=/usr dist-xen
%endif

sed -E -i 's/(as_fn_error \$\? "cannot find wget or ftp" "\$LINENO" 5)/as_fn_status $?/' tools/configure
sed -E -i 's/(as_fn_error \$\? "cannot find wget or ftp" "\$LINENO" 5)/as_fn_status $?/' stubdom/configure
./configure --disable-seabios --build=%{_target_platform} \
        --prefix=%{_prefix} \
        --exec-prefix=%{_exec_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --sysconfdir=%{_sysconfdir} \
        --datadir=%{_datadir} \
        --includedir=%{_includedir} \
        --libdir=%{_libdir} \
        --libexecdir=%{_libexecdir} \
        --localstatedir=%{_localstatedir} \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir}
%make prefix=/usr dist-tools
make  prefix=/usr dist-docs
unset CFLAGS
make dist-stubdom

%install
rm -rf %{buildroot}

%ifarch %{ix86}
cat > README.install.urpmi <<_EOF
Since xen 4.3, the hypervisor is no longer supported on x86_32. But fear not,
you can actually use the x86_64 xen hypervisor, even when using a 32bit kernel
and system. This is because the hypervisor is loaded before the kernel and OS.
Keep in mind that a x86_64 capable processor is still required, but then if
you are installing a hypervisor, you really should be using 64bit anyway.
_EOF
ln README.install.urpmi README.4.3.0.upgrade.urpmi
%else
make DESTDIR=%{buildroot} prefix=/usr install-xen
%endif

make DESTDIR=%{buildroot} prefix=/usr install-tools
make DESTDIR=%{buildroot} prefix=/usr install-docs
make DESTDIR=%{buildroot} prefix=/usr install-stubdom

# stubdom: newlib
rm -rf %{buildroot}/usr/*-xen-elf

# remove additional kernel symlink
rm -f %{buildroot}/boot/xen-3.4.gz
rm -f %{buildroot}/boot/xen-3.gz

# remove unwanted firmware files
rm -rf %{buildroot}/lib/firmware

# remove pointless helper
rm -f %{buildroot}%{_sbindir}/xen-python-path

# remove  README's not intended for end users
rm -f %{buildroot}/%{_sysconfdir}/xen/README*

# fix man pages
install -d -m 755 %{buildroot}%{_mandir}/man{1,5}
install -m 644 docs/man/*.1 %{buildroot}%{_mandir}/man1
install -m 644 docs/man/*.5 %{buildroot}%{_mandir}/man5

# install doc manually
rm -rf %{buildroot}%{_docdir}/qemu
install -d -m 755 %{buildroot}%{_docdir}/%{name}
install -m 644 README %{buildroot}%{_docdir}/%{name}
install -d -m 755 %{buildroot}%{_docdir}/%{name}/txt
install -d -m 755 %{buildroot}%{_docdir}/%{name}/html
cp -R docs/txt/* %{buildroot}%{_docdir}/%{name}/txt/
cp -R docs/html/* %{buildroot}%{_docdir}/%{name}/html/

# install log directory
install -d -m 755 %{buildroot}%{_localstatedir}/log/xen

# install state directory
install -d -m 755 %{buildroot}%{_localstatedir}/lib/xend/{domains,state,storage}

install -m 755 %{SOURCE20} %{buildroot}%{_initrddir}/xenstored
install -m 755 %{SOURCE21} %{buildroot}%{_initrddir}/xenconsoled
install -m 755 %{SOURCE22} %{buildroot}%{_initrddir}/blktapctrl
install -m 755 %{SOURCE23} %{buildroot}%{_initrddir}/xend

# sysconfig
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE30} %{buildroot}%{_sysconfdir}/sysconfig/xenstored
install -m 644 %{SOURCE31} %{buildroot}%{_sysconfdir}/sysconfig/xenconsoled
install -m 644 %{SOURCE32} %{buildroot}%{_sysconfdir}/sysconfig/blktapctrl

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/modules
install -m 755 %{SOURCE1} \
    %{buildroot}%{_sysconfdir}/sysconfig/modules/%{name}.modules 

# tmpfiles
install -D -p -m 0644 %{SOURCE33} %{buildroot}%{_tmpfilesdir}/%{name}.conf

# udev
#rm -rf %{buildroot}/etc/udev/rules.d/xen*.rules
#mv %{buildroot}/etc/udev/rules.d/xen*.rules %{buildroot}/etc/udev/rules.d
mkdir -p %{buildroot}%{_udevrulesdir}
mv %{buildroot}%{_sysconfdir}/udev/rules.d/xen*.rules %{buildroot}%{_udevrulesdir}

# quite some hardcoded paths inside scripts rely on this
%if "%{_lib}" != "lib"
mv %{buildroot}%{_libdir}/xen/bin/libxl-save-helper %{buildroot}%{_prefix}/lib/xen/bin/
%endif

# move ocaml stubs to correct dir
mkdir -p %{buildroot}%{_libdir}/ocaml/stublibs/
mv %{buildroot}%{_libdir}/ocaml/*/dll*_stubs.so %{buildroot}%{_libdir}/ocaml/stublibs/

# logrotate
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/xen <<EOF
/var/log/xen/xend-debug.log /var/log/xen/xen-hotplug.log
/var/log/xen/domain-builder-ng.log {
    notifempty
    missingok
    copytruncate
}
EOF

# standard gnu info files
rm -rf %{buildroot}/usr/info

# gprintify has a bug handling some constructs in xendomain
export DONT_GPRINTIFY=1

%post
%_tmpfilescreate %{name}
%_post_service xencommons
%_post_service xend
%_post_service xendomains

%preun
%_preun_service xendomains
%_preun_service xend
%_preun_service xencommons

%clean
rm -rf %{buildroot}

%files
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/README
%{_sysconfdir}/bash_completion.d/xl.sh
%{_udevrulesdir}/xen*.rules
%dir %{_sysconfdir}/xen
%{_sysconfdir}/xen/scripts
%{_sysconfdir}/xen/auto
%config(noreplace) %{_sysconfdir}/xen/*.sxp
%config(noreplace) %{_sysconfdir}/xen/*.xml
%config(noreplace) %{_sysconfdir}/xen/xmexample*
%config(noreplace) %{_sysconfdir}/xen/xlexample*
%config(noreplace) %{_sysconfdir}/xen/cpupool
%config(noreplace) %{_sysconfdir}/xen/xl.conf
%config(noreplace) %{_sysconfdir}/xen/oxenstored.conf
%{_mandir}/man*/*
%{_libdir}/xen
%if "%{_lib}" != "lib"
%{_prefix}/lib/xen
%endif
%{_libdir}/fs
%{py_platsitedir}/xen
%{py_platsitedir}/grub/*
%{py_platsitedir}/fsimage.so
%{py_platsitedir}/pygrub-0.3-py%{pyver}.egg-info
%{py_platsitedir}/xen-3.0-py%{pyver}.egg-info
%{_datadir}/xen
%{_localstatedir}/log/xen
# general xen state
%{_localstatedir}/lib/xen
%{_localstatedir}/lib/xend
# xenstore state
%{_localstatedir}/lib/xenstored
# init scripts
%{_initrddir}/xend
%{_initrddir}/xendomains
%{_initrddir}/blktapctrl
%{_initrddir}/xenstored
%{_initrddir}/xenconsoled
%{_initrddir}/xen-watchdog
%{_initrddir}/xencommons
%{_sysconfdir}/sysconfig/modules/xen.modules
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains
%config(noreplace) %{_sysconfdir}/sysconfig/blktapctrl
%config(noreplace) %{_sysconfdir}/sysconfig/xenstored
%config(noreplace) %{_sysconfdir}/sysconfig/xenconsoled
%config(noreplace) %{_sysconfdir}/sysconfig/xencommons
%config(noreplace) %{_sysconfdir}/logrotate.d/xen
%{_tmpfilesdir}/%{name}.conf
%{_sbindir}/xenstored
%{_sbindir}/xm
%{_sbindir}/xend
%{_sbindir}/xenconsoled
%{_sbindir}/xentop
%{_sbindir}/xen-bugtool
%{_sbindir}/xenbaked
%{_sbindir}/xenmon.py
%{_sbindir}/blktapctrl
%{_sbindir}/img2qcow
%{_sbindir}/qcow-create
%{_sbindir}/qcow2raw
%{_sbindir}/tapdisk
%{_sbindir}/xentrace_setmask
%{_sbindir}/flask-loadpolicy
%{_sbindir}/xsview
%{_sbindir}/xencov
%{_sbindir}/xenperf
%{_sbindir}/xenpm
%{_sbindir}/xenpmd
%{_sbindir}/flask-getenforce
%{_sbindir}/flask-setenforce
%{_sbindir}/flask-get-bool
%{_sbindir}/flask-set-bool
%{_sbindir}/flask-label-pci
%{_sbindir}/gtracestat
%{_sbindir}/gtraceview
%{_sbindir}/lock-util
%{_sbindir}/tapdisk-client
%{_sbindir}/tapdisk-diff
%{_sbindir}/tapdisk-stream
%{_sbindir}/tapdisk2
%{_sbindir}/td-util
%{_sbindir}/vhd-update
%{_sbindir}/vhd-util
%{_sbindir}/xen-hvmctx
%{_sbindir}/xen-tmem-list-parse
%{_sbindir}/xenlockprof
%{_sbindir}/xen-lowmemd
%{_sbindir}/xen-ringwatch
%{_sbindir}/xl
%{_sbindir}/gdbsx
%{_sbindir}/kdd
%{_sbindir}/oxenstored
%{_sbindir}/tap-ctl
%{_sbindir}/xen-hptool
%{_sbindir}/xen-hvmcrash
%{_sbindir}/xenwatchdogd
%{_bindir}/xencons
%{_bindir}/xencov_split
%{_bindir}/xentrace
%{_bindir}/xentrace_format
%{_bindir}/xentrace_setsize
%{_bindir}/xenstore-*
%{_bindir}/pygrub
%{_bindir}/remus
%{_bindir}/xen-detect
%{_bindir}/qemu-img-xen
%{_bindir}/qemu-nbd-xen
%{_bindir}/xenstore

%files -n ocaml-xen
%exclude %{_libdir}/ocaml/*/*.a
%exclude %{_libdir}/ocaml/*/*.cmxa
%exclude %{_libdir}/ocaml/*/*.cmx
%{_libdir}/ocaml/*

%files -n ocaml-xen-devel
%{_libdir}/ocaml/*/*.a
%{_libdir}/ocaml/*/*.cmxa
%{_libdir}/ocaml/*/*.cmx

%files hypervisor
%ifarch %{ix86}
%doc README.4.3.0.upgrade.urpmi README.install.urpmi
%else
/boot/xen-syms-*
/boot/xen-*.gz
/boot/xen.gz
%endif

%files doc
%{_docdir}/%{name}/*
%exclude %{_docdir}/%{name}/README
%doc docs/txt/* docs/html/*

%files -n %{libname}
%{_libdir}/*.so.*

%files -n %{develname}
%{_includedir}/xen
%{_includedir}/xenstore-compat
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a


%changelog
* Fri Nov 08 2013 alien <alien> 4.3.1-2.mga4
+ Revision: 550006
- Fix XSA-75(No CVE yet) - Host crash due to guest VMX instruction execution

* Sun Nov 03 2013 alien <alien> 4.3.1-1.mga4
+ Revision: 549232
- Update to version 4.3.1

* Fri Nov 01 2013 alien <alien> 4.3.0-7.mga4
+ Revision: 548766
- fix Security bug XSA73/No CVE yet - Lock order reversal between page allocation and grant table locks

* Tue Oct 29 2013 alien <alien> 4.3.0-6.mga4
+ Revision: 547869
- Security fix XSA72/CVE-2013-4416: ocaml xenstored mishandles oversized message replies

* Tue Oct 22 2013 umeabot <umeabot> 4.3.0-5.mga4
+ Revision: 544714
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 pterjan <pterjan> 4.3.0-4.mga4
+ Revision: 500002
- Rebuild to add different pythonegg provides for python 2 and 3

* Mon Oct 14 2013 alien <alien> 4.3.0-3.mga4
+ Revision: 497613
+ rebuild (emptylog)

* Mon Oct 14 2013 alien <alien> 4.3.0-2.mga4
+ Revision: 497500
- fix building in 32bit

* Mon Oct 14 2013 alien <alien> 4.3.0-1.mga4
+ Revision: 497469
- Exclude unsupported i586 hypervisor
- Fix building without fetcher
- Update to new version 4.3.0
- include polarssl for stubdom
- add xencov & xencov_split executables
- rediff xencommon patch
- remove upstreamed patches
- Fix XSA62,XSA63,XSA64,XSA66,XSA67,XSA68,XSA69,XSA70: CVE-2013-1442, CVE-2013-4355, CVE-2013-4356, CVE-2013-4361, CVE-2013-4368, CVE-2013-4369, CVE-2013-4370, CVE-2013-4371

* Wed Jun 12 2013 tv <tv> 4.2.2-1.mga4
+ Revision: 442161
- add man fix from FC
- new release
- drop merged patches
- drop useless gcc-4.5 support patch
- add security patches from FC

  + fwang <fwang>
    - rebuild for new brlapi

* Thu May 02 2013 alien <alien> 4.2.1-16.mga3
+ Revision: 412012
- Fix CVE-2013-1918 and CVE-2013-1952

* Thu Apr 18 2013 alien <alien> 4.2.1-15.mga3
+ Revision: 410438
- Fix CVE-2013-1917 & CVE-2013-1919

* Wed Apr 17 2013 alien <alien> 4.2.1-14.mga3
+ Revision: 410392
- Fix CVE-2013-1920
- Fix CVE-2012-5634, CVE-2013-0151, CVE-2013-0152, CVE-2013-0153, CVE-2013-0154 & CVE-2013-0215

* Tue Apr 09 2013 alien <alien> 4.2.1-12.mga3
+ Revision: 409145
- Fix libvirtd crash after shutdown guest

* Fri Apr 05 2013 alien <alien> 4.2.1-11.mga3
+ Revision: 408343
- fix missing requires

* Thu Apr 04 2013 alien <alien> 4.2.1-10.mga3
+ Revision: 407565
- fix and split ocaml packages

* Sat Mar 30 2013 tv <tv> 4.2.1-9.mga3
+ Revision: 406775
- patch 4: fix qemu-system-i386 path in xencommons service (mga#9294)

* Sun Mar 24 2013 colin <colin> 4.2.1-8.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Sun Mar 03 2013 alien <alien> 4.2.1-7.mga3
+ Revision: 401283
- typo in filename
- helperscripts are only moved if different arch
- Move helper scripts to location they are looked after by various scripts and hardcoded binaries

* Sat Mar 02 2013 alien <alien> 4.2.1-6.mga3
+ Revision: 401170
- Fix creation of log directory

* Sat Mar 02 2013 alien <alien> 4.2.1-5.mga3
+ Revision: 401025
- Fix xenstored detection

* Wed Jan 16 2013 colin <colin> 4.2.1-4.mga3
+ Revision: 388627
- Use tmpfiles to create /run dirs.

* Mon Jan 14 2013 umeabot <umeabot> 4.2.1-3.mga3
+ Revision: 386743
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jan 13 2013 alien <alien> 4.2.1-2.mga3
+ Revision: 361563
- Fix udev migration
- fix /run being tmpfs

* Tue Jan 08 2013 alien <alien> 4.2.1-1.mga3
+ Revision: 343172
- Update to new version

* Thu Aug 23 2012 guillomovitch <guillomovitch> 4.1.3-1.mga3
+ Revision: 283231
- new version

  + alien <alien>
    - add security patches

* Sun Jun 10 2012 tv <tv> 4.1.2-5.mga3
+ Revision: 259292
- require kmod instead of module-init-tools

* Mon Mar 26 2012 alien <alien> 4.1.2-4.mga2
+ Revision: 226967
- Fix for dom0 .xz compressed kernels

* Tue Mar 13 2012 guillomovitch <guillomovitch> 4.1.2-3.mga2
+ Revision: 223229
- debian patch for CVE-2012-0029

* Tue Mar 06 2012 malo <malo> 4.1.2-2.mga2
+ Revision: 219491
- rebuild for new vde
- rename xen-ocaml to ocaml-xen, per OCaml policy

* Wed Jan 25 2012 tmb <tmb> 4.1.2-1.mga2
+ Revision: 201370
- update to 4.1.2
- kernel-xen-pvops is now merged with kernel-server
- drop defattr

* Thu Nov 03 2011 dmorgan <dmorgan> 4.1.1-2.mga2
+ Revision: 161928
- Change tetex-texi2html into texi2html

  + fwang <fwang>
    - drop invalid Default-Enabled keyword
    - br gcrypt

  + tv <tv>
    - new release

* Mon Apr 11 2011 tmb <tmb> 4.1.0-2.mga1
+ Revision: 83471
- rebuild for missing x86_64 packages

* Sun Apr 10 2011 tmb <tmb> 4.1.0-1.mga1
+ Revision: 83034
- update to 4.1.0
- add ipxe sources
- require kernel-xen-pvops

* Mon Mar 07 2011 saispo <saispo> 4.0.1-1.mga1
+ Revision: 65925
- imported package xen

